/**
* DO NOT EDIT THIS FILE.
* See the following change record for more information,
* https://www.drupal.org/node/2815083
* @preserve
**/

(function ($, _ref) {
  var ajax = _ref.ajax,
      behaviors = _ref.behaviors,
      debounce = _ref.debounce;

  behaviors.layoutBuilderBlockFilter = {
    attach: function attach(context) {
      var $input = $('input.js-layout-builder-filter', context).once('block-filter-text');
      var $categories = $('.js-layout-builder-categories', context);
      var $filterLinks = void 0;

      function filterBlockList(e) {
        var query = $(e.target).val().toLowerCase();

        function toggleBlockEntry(index, link) {
          var $link = $(link);
          var textMatch = $link.text().toLowerCase().indexOf(query) !== -1;
          $link.toggle(textMatch);
        }

        $categories.find('.js-layout-builder-category').show();
        $filterLinks.show();

        if (query.length >= 2) {
          $categories.find('.js-layout-builder-category').attr('open', '');
          $filterLinks.each(toggleBlockEntry);
          $categories.find('.js-layout-builder-category').each(function () {
            var hasBlocks = $(this).find('.js-layout-builder-block-link:visible').length > 0;
            $(this).toggle(hasBlocks);
          });
          Drupal.announce(Drupal.formatPlural($categories.find('.js-layout-builder-block-link:visible').length, '1 block is available in the modified list.', '@count blocks are available in the modified list.'));
        }
      }

      if ($input.length) {
        $filterLinks = $categories.find('.js-layout-builder-block-link');
        $input.on('keyup', debounce(filterBlockList, 200));
      }
    }
  };
  behaviors.layoutBuilderBlockDrag = {
    attach: function attach(context) {
      $(context).find('.layout-builder--layout__region').sortable({
        items: '> .draggable',
        connectWith: '.layout-builder--layout__region',
        placeholder: 'ui-state-drop',

        update: function update(event, ui) {
          var itemRegion = ui.item.closest('.layout-builder--layout__region');
          if (event.target === itemRegion[0]) {
            var deltaTo = ui.item.closest('[data-layout-delta]').data('layout-delta');

            var deltaFrom = ui.sender ? ui.sender.closest('[data-layout-delta]').data('layout-delta') : deltaTo;
            ajax({
              url: [ui.item.closest('[data-layout-update-url]').data('layout-update-url'), deltaFrom, deltaTo, itemRegion.data('region'), ui.item.data('layout-block-uuid'), ui.item.prev('[data-layout-block-uuid]').data('layout-block-uuid')].filter(function (element) {
                return element !== undefined;
              }).join('/')
            }).execute();
          }
        }
      });
    }
  };
})(jQuery, Drupal);